#property indicator_separate_window
#property indicator_minimum -1.3
#property indicator_maximum 1.3
#property indicator_buffers 1
#property indicator_color1 Lime
#property indicator_level1 0.9
#property indicator_level2 -0.9
#property indicator_level3 0.75
#property indicator_level4 -0.75

extern int TotalBars = 700;
extern int SnakeRange = 14;
extern int FilterPeriod = 21;
extern double MartFiltr = 2.0;
extern int PriceConst = 6;
double gda_100[];
double gda_104[];
double gda_108[];
int gi_112 = 14;
double gda_116[];
double gd_120;
int gia_128[];
int gia_132[];

// 15EAF6D521704D0194B14E496A74E1EE
void f0_0(int ai_0) {
   int li_4;
   int li_8;
   int li_16;
   double ld_24;
   gda_104[ai_0] = iMA(NULL, 0, SnakeRange + 1, 0, MODE_LWMA, PriceConst, ai_0);
   for (int li_20 = ai_0 + SnakeRange + 2; li_20 > ai_0; li_20--) {
      ld_24 = 0.0;
      li_4 = 0;
      li_8 = 0;
      for (int li_12 = li_20 + SnakeRange; li_12 >= li_20; li_12--) {
         li_8++;
         ld_24 += li_8 * f0_2(li_12);
         li_4 += li_8;
      }
      li_16 = li_20 - SnakeRange;
      if (li_16 < ai_0) li_16 = ai_0;
      while (li_12 >= li_16) {
         li_8--;
         ld_24 += li_8 * f0_2(li_12);
         li_4 += li_8;
         li_12--;
      }
      gda_104[li_20] = ld_24 / li_4;
   }
}

// 5ABFF314964674A606FC93AD8B35C31B
double f0_2(int ai_0) {
   switch (PriceConst) {
   case PRICE_CLOSE:
      return (Close[ai_0]);
   case PRICE_OPEN:
      return (Open[ai_0]);
   case PRICE_HIGH:
      return (High[ai_0]);
   case PRICE_LOW:
      return (Low[ai_0]);
   case PRICE_MEDIAN:
      return ((High[ai_0] + Low[ai_0]) / 2.0);
   case PRICE_TYPICAL:
      return ((Close[ai_0] + High[ai_0] + Low[ai_0]) / 3.0);
   case PRICE_WEIGHTED:
      return ((2.0 * Close[ai_0] + High[ai_0] + Low[ai_0]) / 4.0);
   }
   return (Close[ai_0]);
}

// BFFCA781645251F48D9246A28A0FF279
void f0_4(int ai_0) {
   double ld_4 = gda_104[ArrayMaximum(gda_104, FilterPeriod, ai_0)];
   double ld_12 = gda_104[ArrayMinimum(gda_104, FilterPeriod, ai_0)];
   gda_108[ai_0] = (2.0 * (MartFiltr + 2.0) * gda_104[ai_0] - (ld_4 + ld_12)) / 2.0 / (MartFiltr + 1.0);
}

// 22175D8D43CCB90D592280A5D63DD668
double f0_1(double ada_0[], int ai_4) {
   double ld_16;
   for (int li_24 = 0; li_24 < ai_4; li_24++) ld_16 += MathPow(ada_0[li_24] - li_24 - 1.0, 2);
   double ld_8 = 1 - 6.0 * ld_16 / (MathPow(ai_4, 3) - ai_4);
   return (ld_8);
}

// 6891180C583D478DF8E2EF1F9FD17D72
void f0_3(int aia_0[]) {
   double ld_4;
   double ld_12;
   int li_24;
   int li_32;
   int li_36;
   int li_40;
   double lda_44[];
   ArrayResize(lda_44, gi_112);
   ArrayCopy(gia_132, aia_0);
   for (int li_20 = 0; li_20 < gi_112; li_20++) lda_44[li_20] = li_20 + 1;
   ArraySort(gia_132, WHOLE_ARRAY, 0, MODE_DESCEND);
   for (li_20 = 0; li_20 < gi_112 - 1; li_20++) {
      if (gia_132[li_20] == gia_132[li_20 + 1]) {
         li_32 = gia_132[li_20];
         li_24 = li_20 + 1;
         li_36 = 1;
         ld_12 = li_20 + 1;
         while (li_24 < gi_112) {
            if (gia_132[li_24] != li_32) break;
            li_36++;
            ld_12 += li_24 + 1;
            li_24++;
         }
         ld_4 = li_36;
         ld_12 /= ld_4;
         for (int li_28 = li_20; li_28 < li_24; li_28++) lda_44[li_28] = ld_12;
         li_20 = li_24;
      }
   }
   for (li_20 = 0; li_20 < gi_112; li_20++) {
      li_40 = aia_0[li_20];
      for (li_24 = 0; li_24 < gi_112; li_24++) {
         if (li_40 == gia_132[li_24]) {
            gda_116[li_20] = lda_44[li_24];
            break;
         }
      }
   }
}

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   IndicatorBuffers(3);
   SetIndexBuffer(0, gda_100);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(1, gda_104);
   SetIndexStyle(1, DRAW_NONE);
   SetIndexBuffer(2, gda_108);
   SetIndexStyle(2, DRAW_NONE);
   ArrayResize(gda_116, gi_112);
   ArrayResize(gia_128, gi_112);
   ArrayResize(gia_132, gi_112);
   if (gi_112 > 30) IndicatorShortName("Decrease rangeN input!");
   else IndicatorShortName("BestTrend( SR:" + SnakeRange + ", FP:" + FilterPeriod + " )");
   gd_120 = MathPow(10, Digits);
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int li_8;
   int li_12;
   int li_16;
   int li_20 = TotalBars;
   if (gi_112 > 30) return (-1);
   if (li_20 == 0) {
      li_8 = TotalBars - (gi_112 + FilterPeriod + SnakeRange + 4);
      li_12 = TotalBars - (SnakeRange + 2);
      li_16 = TotalBars - (FilterPeriod + SnakeRange + 3);
   }
   if (li_20 > 0) {
      li_8 = TotalBars + 1;
      li_12 = li_8;
      li_16 = li_8;
   }
   for (int li_0 = li_12; li_0 >= 0; li_0--) f0_0(li_0);
   for (li_0 = li_16; li_0 >= 0; li_0--) f0_4(li_0);
   for (li_0 = li_8; li_0 >= 0; li_0--) {
      for (int li_4 = 0; li_4 < gi_112; li_4++) gia_128[li_4] = (gda_108[li_0 + li_4]) * gd_120;
      f0_3(gia_128);
      gda_100[li_0] = f0_1(gda_116, gi_112);
      if (gda_100[li_0] > 1.0) gda_100[li_0] = 1.0;
      if (gda_100[li_0] < -1.0) gda_100[li_0] = -1.0;
   }
   return (0);
}